const forge = require('node-forge');

const keyPair = forge.pki.rsa.generateKeyPair({ bits: 2048, e: 0x10001});

const certificado = forge.pki.createCertificate();

certificado.publicKey = keyPair.publicKey;

certificado.validity.notBefore = new Date();
certificado.validity.notAfter = new Date();
certificado.validity.notAfter.setFullYear(certificado.validity.notBefore.getFullYear() + 1);

const atributos = [{
  name: 'commonName',
  value: 'Juan Perez'
}];
certificado.setSubject(atributos);
certificado.setIssuer(atributos);

certificado.sign(keyPair.privateKey);

const md = forge.md.sha256.create();

md.update('Cadena que se desea firmar.');

const firma = keyPair.privateKey.sign(md);

const docFirmado = {};
docFirmado.body = 'Cadena que se desea firmar.';
docFirmado.firma = Buffer.from(firma, 'binary').toString('base64');
docFirmado.certificado = forge.pki.certificateToPem(certificado);
console.log(docFirmado);

const md2 = forge.md.sha256.create();
md2.update(docFirmado.body);
console.log(forge.pki.certificateFromPem(docFirmado.certificado).publicKey.verify(md2.digest().bytes(), Buffer.from(docFirmado.firma, 'base64').toString('binary')));

const md3 = forge.md.sha256.create();
md3.update('Cadena que se desea firmar');
console.log(certificado.publicKey.verify(md3.digest().bytes(), firma));
